      PROGRAM INSTAL
************************************************************************
*                                                                      *
*          This is the Merlin/MCL-3.0 installer program                *
*                                                                      *
*  Implemented by:                                                     *
*         D. G. Papageorgiou                                           *
*         Dept. of Chemistry, University of Ioannina, GREECE.          *
*         E-mail: jimmy@nrt.cs.uoi.gr                                  *
*                                                                      *
*         I. E. Lagaris                                                *
*         Dept. of Computer Science, University of Ioannina, GREECE.   *
*         E-mail: lagaris@cs.uoi.gr                                    *
*                                                                      *
*         I. N. Demetropoulos                                          *
*         Dept. of Chemistry, University of Ioannina, GREECE.          *
*         E-mail: idimitr@cc.uoi.gr                                    *
*                                                                      *
*  All authors can be reached at: merlin@nrt.cs.uoi.gr                 *
*  More information is available at: http://nrt.cs.uoi.gr/merlin       *
*                                                                      *
************************************************************************
C
C  Local variables:
      CHARACTER*10 ANSWER, STR, STR2
      CHARACTER*80 DEFS, FMER1, FMER2, FMERS1, FMERS2, FMCL1, FMCL2
      CHARACTER*20 TYPE
      DOUBLE PRECISION DP
      LOGICAL EX
      LOGICAL YES, NO
      YES(ANSWER) = ANSWER.EQ.'YES' .OR. ANSWER.EQ.'Y'
      NO(ANSWER)  = ANSWER.EQ.'NO'  .OR. ANSWER.EQ.'N'
C  ---------------------------------------------------------------------
C
C  Display initial welcome message.
      WRITE (*,*)
      WRITE (*,*)
      WRITE (*,*)
      WRITE (*,10) 'Welcome to the Merlin/MCL installation program'
      WRITE (*,10) '----------------------------------------------'
      WRITE (*,*)
      WRITE (*,*)
      WRITE (*,10) 'The Merlin/MCL source is not distributed as a '//
     &             'pure Fortran-77'
      WRITE (*,10) 'program. Instead, symbolic names of the form '//
     &             '$(NAME) are used'
      WRITE (*,10) 'for some definitions in the source (mainly in '//
     &             'parameter'
      WRITE (*,10) 'statements). These symbolic names must be '//
     &             'substituted with'
      WRITE (*,10) 'actual values, at installation time, before '//
     &             'compilation can '
      WRITE (*,10) 'take place. This way, one can easily adjust a '//
     &             'large number of'
      WRITE (*,10) 'parameters, without actualy dealing with the '//
     &             'Merlin source code.'
      WRITE (*,*)
      WRITE (*,10) 'Installation is carried out in three phases:'
      WRITE (*,10) '1) The installer will help you create a file '//
     &             'of definitions.'
      WRITE (*,10) '2) It then will consult this file, read the '//
     &             'contents of the Merlin/MCL'
      WRITE (*,10) 'distribution files, and output the full '//
     &             'Fortran-77 source, ready'
      WRITE (*,10) 'for compilation.'
      WRITE (*,10) '3) You must invoce your compiler and compile '//
     &             'the Merlin/MCL package.'
      CALL CONT
C
C  Phase 1.
      WRITE (*,*)
      WRITE (*,*)
      WRITE (*,*)
      WRITE (*,10) 'Phase 1: Creation of the installer definitions file'
      WRITE (*,10) '---------------------------------------------------'
C
C  Have you prepared a definitions file  ?
40    CONTINUE
      WRITE (*,*)
      WRITE (*,10) 'Have you already prepared a file with installer '//
     &             'definitions ?'
      WRITE (*,10) 'If this is the first time you run the installer, '//
     &             'answer No.'
      WRITE (*,10) 'You may answer:  [ Yes, No ] (Default=No)'
      READ (*,20) ANSWER
      IF (ANSWER.EQ.' ') ANSWER = 'NO'
      CALL UPPER(ANSWER,LEN(ANSWER))
      IF (YES(ANSWER)) THEN
50       CONTINUE
         WRITE (*,*)
         WRITE (*,10) 'Name your installer definitions file:'
         WRITE (*,10) 'You may answer: [ Any existing file ] '//
     &                   '(Default=DEFS)'
         READ (*,'(A)') DEFS
         IF (DEFS.EQ.' ') DEFS = 'DEFS'
         INQUIRE (FILE=DEFS,EXIST=EX)
         IF (.NOT.EX) THEN
            LE = LENGTH(DEFS)
            WRITE (*,140) DEFS(1:LE)
            GOTO 50
         END IF
         WRITE (*,10) 'Will use the installer definitions file: '//DEFS
         GOTO 100
      ELSE IF (NO(ANSWER)) THEN
         DEFS = 'DEFS'
      ELSE
         GOTO 40
      END IF
C
C  Go on and create a definitions file.
      WRITE (*,*)
      WRITE (*,10) 'You will now be prompted for the various '//
     &             'options, and your answers'
      WRITE (*,10) 'will be recorded in the default installer '//
     &             'definitions file "DEFS".'
      CALL CONT
C
C  Ask for the precision.
      CALL SMACAC(SP)
      CALL DMACAC(DP)
60    CONTINUE
      WRITE (*,*)
      WRITE (*,10) 'The Merlin/MCL package can be installed in '//
     &             'single or double precision.'
      WRITE (*,10) 'Your machine''s accuracy, as estimated by the '//
     &             'Installer is:'
      WRITE (*,30) SP
      WRITE (*,35) DP
      WRITE (*,10) 'Would you like a single or double precision '//
     &             'installation ?'
      WRITE (*,10) 'You may answer: [ Single, Double ] (Default=Double)'
      READ (*,20) ANSWER
      IF (ANSWER.EQ.' ') ANSWER = 'DOUBLE'
      CALL UPPER(ANSWER,LEN(ANSWER))
      IF (ANSWER.EQ.'SINGLE' .OR. ANSWER.EQ.'S') THEN
         TYPE = 'REAL'
         WRITE (*,10) 'Will perform a single precision installation.'
      ELSE IF (ANSWER.EQ.'DOUBLE' .OR. ANSWER.EQ.'D') THEN
         TYPE = '''DOUBLE PRECISION'''
         WRITE (*,10) 'Will perform a double precision installation.'
      ELSE
         GOTO 60
      END IF
C
C  Ask for the dimensionality and number of terms.
      WRITE (*,*)
      WRITE (*,10) 'Merlin uses some one-dimensional arrays as a '//
     &             'working area.'
      WRITE (*,10) 'The space occupied by these arrays depends:'
      WRITE (*,10) 'a) On the dimensionality of your objective '//
     &             'function.'
      WRITE (*,10) 'b) On the number of terms of your objective '//
     &             'function (if your objective'
      WRITE (*,10) '   function is a sum of squares; a common form '//
     &             'in the case of least squares'
      WRITE (*,10) '   fits (number of your data).'
      WRITE (*,10) 'To avoid unnecessary re-installations, you must '//
     &             'supply the maximum number'
      WRITE (*,10) 'of minimization parameters and terms, you want '//
     &             'this source to handle.'
      WRITE (*,10) 'Remember that Merlin, for some operations, '//
     &             'needs a 2-dimensional storage'
      WRITE (*,10) 'as well, which must be provided by your main '//
     &             'program.'
80    CONTINUE
      WRITE (*,*)
      WRITE (*,10) 'What is the maximum dimensionality of the '//
     &             'objective function ?'
      WRITE (*,10) 'You may answer: [ Any positive integer ] '//
     &             '(Default=200)'
      READ (*,20) STR
      IF (STR.EQ.' ') STR = '200'
      LE = LENGTH(STR)
      CALL TOINT(STR,LE,MXV,IERR)
      IF (IERR.NE.0) GOTO 80
      IF (MXV.LT.1) GOTO 80
90    CONTINUE
      WRITE (*,*)
      WRITE (*,10) 'What is the maximum number of terms (# of data) ?'
      WRITE (*,10) 'You may answer: [ Any positive integer ] '//
     &             '(Default=200)'
      READ (*,20) STR
      IF (STR.EQ.' ') STR = '200'
      LE = LENGTH(STR)
      CALL TOINT(STR,LE,MXT,IERR)
      IF (IERR.NE.0) GOTO 90
      IF (MXT.LT.1) GOTO 90
      CALL I2STR(MXV,STR,LE)
      CALL I2STR(MXT,STR2,LE2)
      WRITE (*,150) STR(1:LE), STR2(1:LE2)
C
C  Ask if the user is going to run MCL programs.
45    CONTINUE
      WRITE (*,*)
      WRITE (*,10) 'Do you intend to run MCL programs ?'
      WRITE (*,10) 'You may answer: [ Yes, No ] (Default=Yes)'
      READ (*,20) ANSWER
      IF (ANSWER.EQ.' ') ANSWER = 'YES'
      CALL UPPER(ANSWER,LEN(ANSWER))
      IF (YES(ANSWER)) THEN
         MCL = 1
      ELSE IF (NO(ANSWER)) THEN
         MCL = 0
      ELSE
         GOTO 45
      END IF
C
C  Create the macro definitions file.
      CALL CREDEF(DEFS,TYPE,MXV,MXT,MCL)
      LED = LENGTH(DEFS)
      WRITE (*,160) DEFS(1:LED)
C
C  An installer definitions file is ready.
100   CONTINUE
      WRITE (*,*)
      WRITE (*,170)
      CALL CONT
C
C  Phase 2.
      WRITE (*,*)
      WRITE (*,*)
      WRITE (*,*)
      WRITE (*,10) 'Phase 2: Preprocessing of the distribution files'
      WRITE (*,10) '------------------------------------------------'
      WRITE (*,*)
      WRITE (*,10) 'The Merlin/MCL package is usually distributed '//
     &             'in 3 files:'
      WRITE (*,10) '1) The Merlin source code.'
      WRITE (*,10) '2) The Merlin sample main program, objective '//
     &             'function, gradient, etc.'
      WRITE (*,10) '3) The MCL source code.'
C
C  Process the three main distribution files.
      CALL PROC1('Merlin',DEFS,FMER1,FMER2,'merlin.d','merlin.f')
      CALL PROC1('Merlin-sample',DEFS,FMERS1,FMERS2,'sample.d',
     &           'sample.f')
      CALL PROC1('MCL',DEFS,FMCL1,FMCL2,'mcl.d','mcl.f')
C
C  Display a summary of the files that have been processed.
      WRITE (*,*)
      NF = 0
      IF (FMER1.NE.'-' .AND. FMER2.NE.'-') NF = NF+1
      IF (FMERS1.NE.'-' .AND. FMERS2.NE.'-') NF = NF+1
      IF (FMCL1.NE.'-' .AND. FMCL2.NE.'-') NF = NF+1
      IF (NF.EQ.0) THEN
         WRITE (*,180)
      ELSE
         WRITE (*,190)
         IF (FMER1.NE.'-' .AND. FMER2.NE.'-') THEN
            LE1 = MIN(LENGTH(FMER1),20)
            LE2 = MIN(LENGTH(FMER2),20)
            WRITE (*,200) FMER1(1:LE1), FMER2(1:LE2)
         END IF
         IF (FMERS1.NE.'-' .AND. FMERS2.NE.'-') THEN
            LE1 = MIN(LENGTH(FMERS1),20)
            LE2 = MIN(LENGTH(FMERS2),20)
            WRITE (*,200) FMERS1(1:LE1), FMERS2(1:LE2)
         END IF
         IF (FMCL1.NE.'-' .AND. FMCL2.NE.'-') THEN
            LE1 = MIN(LENGTH(FMCL1),20)
            LE2 = MIN(LENGTH(FMCL2),20)
            WRITE (*,200) FMCL1(1:LE1), FMCL2(1:LE2)
         END IF
      END IF
      CALL CONT
C
C  Phase 3.
      WRITE (*,*)
      WRITE (*,*)
      WRITE (*,*)
      WRITE (*,10) 'Phase 3: Compilation'
      WRITE (*,10) '--------------------'
      WRITE (*,*)
      WRITE (*,10) 'You must now compile the source files. The '//
     &             'Installer cannot do this for'
      WRITE (*,10) 'you, since invocation of a compiler is highly '//
     &             'system dependent.'
      WRITE (*,10) 'Remember that MCL is an autonomous program, and '//
     &             'must be compiled alone.'
      WRITE (*,10) 'for example on a Unix system: f77 -O -o mcl mcl.f'
      WRITE (*,*)
      WRITE (*,10) 'The Merlin source must be compiled along with '//
     &             'the sample (or any one'
      WRITE (*,10) 'of your objective functions)'
      WRITE (*,10) 'for example on a Unix system: f77 -O -c merlin.f'
      WRITE (*,10) '                              f77 -O -c sample.f'
      WRITE (*,10) '                              f77 -o merlin '//
     &             'merlin.o sample.o'
      WRITE (*,*)
      LED = LENGTH(DEFS)
      WRITE (*,10) 'Remember to take a look at your installer '//
     &             'definitions file "'//DEFS(1:LED)//'".'
      WRITE (*,10) 'You may wish to keep it for future work.'
      WRITE (*,*)
      WRITE (*,10) 'For assistance, email the Merlin group: '//
     &             'merlin@nrt.cs.uoi.gr'
      WRITE (*,10) 'or check the Merlin webpages: '//
     &             'http://nrt.cs.uoi.gr/merlin'
cc    WRITE (*,*)
cc    WRITE (*,10) 'Good luck.'
C
10    FORMAT (1X,A)
20    FORMAT (A)
30    FORMAT (1X,5X,'Single Precision: ',1PE7.0)
35    FORMAT (1X,5X,'Double Precision: ',1PE7.0)
140   FORMAT (1X,'File "',A,'" does not exist.')
150   FORMAT (1X,'Will use a maximum of ',A,' variables and ',A,
     &        ' terms.')
160   FORMAT (1X,'The installer definitions file "',A,'" has been ',
     &        'created.')
170   FORMAT (1X,'Phase 1 has been completed.')
180   FORMAT (1X,'Phase 2 has been completed. No files have been ',
     &        'processed.')
190   FORMAT (1X,'Phase 2 has been completed. The following files ',
     &        'have been processed:'/
     &        1X,T2,'Distribution Original',T25,'Fortran Source'/
     &        1X,T2,'---------------------',T25,'--------------')
200   FORMAT (1X,T2,A,T25,A)
      END
C  ---------------------------------------------------------------------
      SUBROUTINE CONT
C  ---------------------------------------------------------------------
C
C  Description:
C    Displays the "Enter <cr> to continue" message and waits for
C    the user to hit <cr>.
C
C  ---------------------------------------------------------------------
C  Local variables:
      CHARACTER CR
C  ---------------------------------------------------------------------
C
      WRITE (*,*)
      WRITE (*,10)
      READ (*,20) CR
      IF (ISCOMP(CR,'Q').NE.0) THEN
         WRITE (*,30) 'Installation aborted. Bye.'
         STOP
      END IF
C
10    FORMAT (1X,'Enter <cr> to continue or q to quit')
20    FORMAT (A)
30    FORMAT (1X,A)
      END
C  ---------------------------------------------------------------------
      SUBROUTINE CREDEF ( DEFS, TYPE, MXV, MXT, MCL )
C  ---------------------------------------------------------------------
C
C  Description:
C    Writes a macro description file (DEFS) according to the input 
C    arguments.
C
C  Input arguments:
C    DEFS      The macro definitions file.
C    TYPE      Precision (single or double precision)
C    MXV       Maximum number of variables.
C    MXT       Maximum number of terms.
C    MCL       MCL=1 if the user designated that he is going to use 
C              MCL programs; MCL=0 otherwise.
C
C  ---------------------------------------------------------------------
C  Arguments:
      CHARACTER*(*) DEFS, TYPE
C  ---------------------------------------------------------------------
C  Local variables:
      CHARACTER*10 STR, FC
      CHARACTER*80 CONFIG
C  ---------------------------------------------------------------------
C
C  The installer only asks the values for the most important macros.
C  Supply some reasonable defaults for the rest of them.
      FC = ''''''
      MXPLUG = 50
      CONFIG = 'CONFIG'
      IF (MCL.EQ.0) THEN
         MCLMEM = 1
         MCLBUF = 1
      ELSE
         MCLMEM = 50000
         MCLBUF = 50000
      END IF
C
      OPEN (1,FILE=DEFS)
C
      WRITE (1,20) '%'
      WRITE (1,20) '%  Installer definitions for the Merlin/MCL-3.0'//
     &             ' package.'
      WRITE (1,20) '%'
C
      LE = LENGTH(TYPE)
      WRITE (1,*)
      WRITE (1,20) '%  Real or Double Precision variables.'
      WRITE (1,10) 'TYPE', TYPE(1:LE)
C
      CALL I2STR(MXV,STR,LE)
      WRITE (1,*)
      WRITE (1,20) '%  Maximum number of optimization parameters.'
      WRITE (1,10) 'MXV', STR(1:LE)
C
      CALL I2STR(MXT,STR,LE)
      WRITE (1,*)
      WRITE (1,20) '%  Maximum number of terms in a sum of squares.'
      WRITE (1,10) 'MXT', STR(1:LE)
C
      LE = LENGTH(FC)
      WRITE (1,*)
      WRITE (1,20) '%  Terminal control character. Set FC to ''1X,'''
      WRITE (1,20) '%  to add a control character in every line of'
      WRITE (1,20) '%  printed output.'
      WRITE (1,10) 'FC', FC(1:LE)
C
      LE = LENGTH(CONFIG)
      WRITE (1,*)
      WRITE (1,20) '%  Name of the Merlin/MCL configuration file.'
      WRITE (1,10) 'CONFIG', CONFIG(1:LE)
C
      CALL I2STR(MCLMEM,STR,LE)
      WRITE (1,*)
      WRITE (1,20) '%  MCL memory size. Adjust according to the needs'
      WRITE (1,20) '%  of your MCL programs, or set it to 1 if you'
      WRITE (1,20) '%  dont intend to use MCL.'
      WRITE (1,10) 'MCLMEM', STR(1:LE)
C
      CALL I2STR(MCLBUF,STR,LE)
      WRITE (1,*)
      WRITE (1,20) '%  Character length of the MCL program buffer.'
      WRITE (1,20) '%  This buffer is supposed to hold the entire'
      WRITE (1,20) '%  Merlin Object Code, during execution of'
      WRITE (1,20) '%  an MCL program. Set it to 1 if you dont'
      WRITE (1,20) '%  intend to use MCL. (MCL programs will still'
      WRITE (1,20) '%  run; at a slower pace however.)'
      WRITE (1,10) 'MCLBUF', STR(1:LE)
C
      CALL I2STR(MXPLUG,STR,LE)
      WRITE (1,*)
      WRITE (1,20) '%  Maximum number of plug-ins. If you change the'
      WRITE (1,20) '%  default setting, you must also make the'//
     &             ' necessary'
      WRITE (1,20) '%  modifications in the source code. (Empty'
      WRITE (1,20) '%  plug-ins, call and goto statements.)'
      WRITE (1,10) 'MXPLUG', STR(1:LE)
C
      CLOSE (1)
C
10    FORMAT (A,T12,A)
20    FORMAT (A)
      END
C  ---------------------------------------------------------------------
      SUBROUTINE DMACAC ( COMACC )
C  ---------------------------------------------------------------------
C
C  Description:
C    This routine determines the relative machine accuracy (COMACC)
C    in double precision.
C
C  Output arguments:
C    COMACC     Relative machine accuracy in double precision.
C
C  ---------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      TEN = 10.
      ONE = 1.
      DO 10,I=1,1000
         COMACC = TEN**(-I)
         X1 = ONE+COMACC
         X2 = ONE-COMACC
         IF (X1.EQ.ONE .OR. X2.EQ.ONE) THEN
            COMACC = TEN**(-I+1)
            RETURN
         END IF
10    CONTINUE
C
      END
C  ---------------------------------------------------------------------
      SUBROUTINE I2STR ( N, STR, LES )
C  ---------------------------------------------------------------------
C
C  Description:
C    Converts an integer (N) to its string representation (STR).
C
C  Input arguments:
C    N          The integer to be converted.
C
C  Output arguments:
C    STR        The first LES characters of STR contain the string 
C               representation of N.
C    LES        Effective length of STR.
C
C  ---------------------------------------------------------------------
C  Arguments:
      CHARACTER*(*) STR
C  ---------------------------------------------------------------------
C  Local variables:
      CHARACTER*5 FORM
      DATA FORM / '(I__)' /
C  ---------------------------------------------------------------------
C
      LE = LEN(STR)
      WRITE (FORM(3:4),'(I2.2)') LE
      WRITE (STR,FORM) N
C
      DO 10,I=1,LE
         IF (STR(I:I).NE.' ') THEN
            DO 20,J=I,LE
               JI = J-I+1
               STR(JI:JI) = STR(J:J)
20          CONTINUE
            STR(LE-I+2:) = ' '
            LES = LE-I+1
            RETURN
         END IF
10    CONTINUE
      LES = LE
C
      END
C  ---------------------------------------------------------------------
      LOGICAL FUNCTION ISCAP ( C )
C  ---------------------------------------------------------------------
C
C  Description:
C    Returns .TRUE. if the input character C is a capital letter;
C    .FALSE. otherwise.
C
C  Input arguments:
C    C          Character to check.
C
C  ---------------------------------------------------------------------
C  Arguments:
      CHARACTER C
C  ---------------------------------------------------------------------
C  Local variables:
      CHARACTER*26 LETT
      DATA LETT / 'ABCDEFGHIJKLMNOPQRSTUVWXYZ' /
C  ---------------------------------------------------------------------
C
      ISCAP = INDEX(LETT,C).NE.0
      END
C  ---------------------------------------------------------------------
      FUNCTION ISCOMP ( A, B )
C  ---------------------------------------------------------------------
C
C  Description:
C    Performs a case insensitive comparison of the two character strings
C    A and B. Returns 0 if they don't match, non-zero if they match.
C
C  Input arguments:
C    A          The first of the two strings to be compared.
C    B          The second of the two strings to be compared.
C
C  ---------------------------------------------------------------------
C  Arguments:
      CHARACTER*(*) A, B
C  ---------------------------------------------------------------------
C  Local variables:
      CHARACTER CA, CB
      LOGICAL BLANK
C  ---------------------------------------------------------------------
C
      LA = LEN(A)
      LB = LEN(B)
C
C  Compare all characters in A and B, one by one.
      LE = MIN(LA,LB)
      DO 10,I=1,LE
         CA = A(I:I)
         CB = B(I:I)
C  Convert to upper case before comparison.
         CALL UPPER(CA,1)
         CALL UPPER(CB,1)
         IF (CA.NE.CB) THEN
            ISCOMP = 0
            RETURN
         END IF
10    CONTINUE
C
C  Blanks at the end of a string are ignored.
      IF (LA.GT.LB) THEN
         BLANK = A(LB+1:) .EQ. ' '
      ELSE IF (LB.GT.LA) THEN
         BLANK = B(LA+1:) .EQ. ' '
      ELSE
         BLANK = .TRUE.
      END IF
C
      IF (BLANK) THEN
         ISCOMP = 1
      ELSE
         ISCOMP = 0
      END IF
C
      END
C  ---------------------------------------------------------------------
      FUNCTION LENGTH ( STRING )
C  ---------------------------------------------------------------------
C
C  Description:
C    Returns the position of the last non-blank non-tab character in
C    the input string, ie. Its effective length.
C
C  Input arguments:
C    STRING    A character variable whose length we seek.
C
C  ---------------------------------------------------------------------
C  Arguments:
      CHARACTER STRING*(*)
C  ---------------------------------------------------------------------
C  Local variables:
      CHARACTER C
C  ---------------------------------------------------------------------
C
      DO 10,I=LEN(STRING),1,-1
         C = STRING(I:I)
         IF (C.NE.' ') THEN
            LENGTH = I
            RETURN
         END IF
10    CONTINUE
      LENGTH = 0
C
      END
C  ---------------------------------------------------------------------
      SUBROUTINE POL ( LINE, MAC, VAL, NMAC )
C  ---------------------------------------------------------------------
C
C  Description:
C    Substitutes the actual values of any macro references in the input
C    LINE. The result is written in unit 2 that is assumed to be 
C    assigned to the output file.
C
C  Input arguments:
C    LINE      A line that possibly contains macro references.
C    MAC       MAC(I) is the name of the I-th macro, as specified
C              in the macro definitions file.
C    VAL       VAL(I) is the actual value of the I-th macro, as 
C              specified in the macro definitions file.
C    NMAC      Number of macro-value pairs.
C
C  ---------------------------------------------------------------------
C  Arguments:
      CHARACTER*(*) LINE, MAC(*), VAL(*)
C  ---------------------------------------------------------------------
C  Local variables:
      PARAMETER ( LINLEN = 80, MAXNIT = LINLEN/2 )
      PARAMETER ( MAXMAC = 100, MACLEN = 20, LENVAL = 20, LENFIL = 20 )
      CHARACTER*(MACLEN) NAME
      CHARACTER*(LINLEN) NEW
      CHARACTER CHA
C  ---------------------------------------------------------------------
C
      LE = LENGTH(LINE)
      NEW = ' '
      IC = 0
      NNLE = 0
C
31    CONTINUE
      IC = IC+1
      IF (IC.GT.LE) GOTO 210
C
      CHA = LINE(IC:IC)
      IF (CHA.NE.'$') THEN
         NNLE = NNLE+1
         NEW(NNLE:NNLE) = CHA
         GOTO 31
      END IF
C
      IC = IC+1
      IF (IC.GT.LE) THEN
         NNLE = NNLE+1
         NEW(NNLE:NNLE) = CHA
         GOTO 31
      END IF
      CHA = LINE(IC:IC)
      IF (CHA.NE.'(') THEN
         NNLE = NNLE+1
         NEW(NNLE:NNLE) = '$'
         NNLE = NNLE+1
         NEW(NNLE:NNLE) = CHA
         GOTO 31
      END IF
C
C  The start of a macro has been located.
      DO 40,K=IC+1,LE
         IF (LINE(K:K).EQ.')') GOTO 41
40    CONTINUE
      NNLE = NNLE+1
      NEW(NNLE:NNLE) = '$'
      NNLE = NNLE+1
      NEW(NNLE:NNLE) = '('
      GOTO 31
C
41    CONTINUE
C
C  The end of a macro has been located at character K.
      IF (K.EQ.IC+1) THEN
C
C  Empty macro.
         DO 51,I=IC-1,IC
            NNLE = NNLE+1
            NEW(NNLE:NNLE) = LINE(I:I)
51       CONTINUE
         GOTO 31
      END IF
C
C  Get the macro name.
      NAME = LINE(IC+1:K-1)
C
C  Convert to upper case.
      LEM = K-IC-1
      CALL UPPER(NAME,LEM)
C
C  Search in the macro table.
      DO 53,I=1,NMAC
         IF (MAC(I).EQ.NAME) GOTO 57
53    CONTINUE
      DO 58,I=IC-1,K
         NNLE = NNLE+1
         NEW(NNLE:NNLE) = LINE(I:I)
58    CONTINUE
      IC = K
      GOTO 31
C
57    CONTINUE
C
C  Substitute the actual value.
      LEV = LENGTH(VAL(I))
      DO 54,J=1,LEV
         NNLE = NNLE+1
         NEW(NNLE:NNLE) = VAL(I)(J:J)
54    CONTINUE
      IC = K
      GOTO 31
C
C  Write the resulting line.
210   CONTINUE
      IF (NNLE.EQ.0) THEN
         WRITE (2,*)
      ELSE
         WRITE (2,'(A)') NEW(1:NNLE)
      END IF
C
      END
C  ---------------------------------------------------------------------
      SUBROUTINE PREP ( MACFIL, SOURCE, OUT )
C  ---------------------------------------------------------------------
C
C  Description:
C    Does the actual macro proccessing. Initially it opens and reads
C    macro definitions from file MACFIL. Then it reads file SOURCE
C    line by line, substituting macro values, and disposing the 
C    resulting lines in file OUT.
C
C  Input arguments:
C    MACFIL    File containing the macro definitions.
C    SOURCE    The source to be processed. It is assumed to contain
C              macro references.
C    OUT       The output file. Here all macro references have been
C              substituted with actual values.
C
C  ---------------------------------------------------------------------
C  Arguments:
      CHARACTER*(*) MACFIL, SOURCE, OUT
C  ---------------------------------------------------------------------
C  Local variables:
      PARAMETER ( LINLEN = 80, MAXNIT = LINLEN/2 )
      PARAMETER ( MAXMAC = 100, MACLEN = 20, LENVAL = 20, LENFIL = 20 )
      CHARACTER*(MACLEN) MAC(MAXMAC)
      CHARACTER*(LENVAL) VAL(MAXMAC)
      CHARACTER*(LINLEN) LINE, NEW
      CHARACTER*(LENFIL) FILE
      DIMENSION IS(MAXNIT), IE(MAXNIT)
      LOGICAL EX
C  ---------------------------------------------------------------------
C
      NMAC = 0
      INQUIRE (FILE=MACFIL,EXIST=EX)
      IF (.NOT.EX) GOTO 800
C
C  Read the macro file.
      OPEN (1,FILE=MACFIL)
10    READ (1,'(A)',END=20) LINE
      CALL QLCR(LINE,LEN(LINE),NEW,IS,IE,NIT,IERR)
C
C  Any error ?
      IF (IERR.NE.0) THEN
         WRITE (*,*) 'PREP: The macro file is incorrect.'
         WRITE (*,'(A)') LINE
         STOP
      END IF
C
C  Empty line ?
      IF (NIT.EQ.0) GOTO 10
C
C  Comment line ?
      IF (NEW(IS(1):IS(1)).EQ.'%') GOTO 10
C
C  Two items only allowed.
      IF (NIT.GT.2) THEN
         WRITE (*,*) 'PREP: Incorrect line in the macro '//
     &                  'description file'
         WRITE (*,'(A)') LINE
         STOP
      END IF
      NMAC = NMAC+1
      IF (NMAC.GT.MAXMAC) THEN
         WRITE (*,*) 'PREP: Too many macros'
         STOP
      END IF
      MAC(NMAC) = NEW(IS(1):IE(1))
      IF (NIT.EQ.1) THEN
         VAL(NMAC) = ' '
      ELSE
         VAL(NMAC) = NEW(IS(2):IE(2))
      END IF
      CALL UPPER(MAC(NMAC),IE(1)-IS(1)+1)
      GOTO 10
C
20    CONTINUE
      CLOSE (1)
C
800   CONTINUE
C
C  The macro description file has been processed.
C  Now process the input file.
      OPEN (1,FILE=SOURCE)
      OPEN (2,FILE=OUT)
30    READ (1,'(A)',END=200) LINE
      CALL QLCR(LINE,LEN(LINE),NEW,IS,IE,NIT,IERR)
C
C  Check for "#include" directives. This is mainly a development aid.
      IF (IERR.EQ.0 .AND. NIT.EQ.2) THEN
         IF (ISCOMP(NEW(IS(1):IE(1)),'#INCLUDE').NE.0) THEN
            FILE = NEW(IS(2):IE(2))
            INQUIRE (FILE=FILE,EXIST=EX)
            IF (EX) THEN
               OPEN (10,FILE=FILE)
400            READ (10,'(A)',END=401) LINE
               CALL POL(LINE,MAC,VAL,NMAC)
               GOTO 400
401            CLOSE (10)
               GOTO 30
            END IF
         END IF
      END IF
      CALL POL(LINE,MAC,VAL,NMAC)
      GOTO 30
C
200   CONTINUE
      CLOSE (1)
      CLOSE (2)
      END
C  ---------------------------------------------------------------------
      SUBROUTINE PROC1 ( DESC, DEFS, FILE1, FILE2, DEF1, DEF2 )
C  ---------------------------------------------------------------------
C
C  Description:
C    Asks the user to enter the input and output file names and calls
C    SUBROUTINE PREP to do the actual macro processing.
C
C  Input arguments:
C    DESC      One word description of the file to be processed.
C    DEFS      File containing the macro definitions.
C    DEF1      Default value for FILE1.
C    DEF2      Default value for FILE2.
C
C  Output arguments:
C    FILE1     Input file name.
C    FILE2     Output (processed) file name.
C
C  ---------------------------------------------------------------------
C  Arguments:
      CHARACTER*(*) DESC, DEFS, FILE1, FILE2, DEF1, DEF2
C  ---------------------------------------------------------------------
C  Local variables:
      LOGICAL EX
C  ---------------------------------------------------------------------
C
      LED = LENGTH(DESC)
      FILE1 = '-'
      FILE2 = '-'
C
C  Ask for the input file name.
10    CONTINUE
      WRITE (*,*)
      WRITE (*,60) DESC(1:LED)
      WRITE (*,40) DEF1
      READ (*,'(A)') FILE1
      IF (FILE1.EQ.' ') FILE1 = DEF1
      IF (FILE1.EQ.'-') THEN
         WRITE (*,90) DESC(1:LED)
         RETURN
      END IF
C
C  Check if it exists.
      LE1 = LENGTH(FILE1)
      INQUIRE (FILE=FILE1,EXIST=EX)
      IF (.NOT.EX) THEN
         WRITE (*,20) FILE1(1:LE1)
         GOTO 10
      END IF
C
C  Ask for the output file name.
      WRITE (*,*)
      WRITE (*,70) DESC(1:LED)
      WRITE (*,40) DEF2
      READ (*,'(A)') FILE2
      IF (FILE2.EQ.' ') FILE2 = DEF2
      IF (FILE2.EQ.'-') THEN
         WRITE (*,90) DESC(1:LED)
         RETURN
      END IF
      LE2 = LENGTH(FILE2)
C
C  Do the actual macro substitutions.
      WRITE (*,50) FILE1(1:LE1)
      CALL PREP(DEFS,FILE1,FILE2)
      WRITE (*,30) FILE1(1:LE1), FILE2(1:LE2)
C
20    FORMAT (1X,'File "',A,'" does not exist.')
30    FORMAT (1X,'File "',A,'" has been processed. Fortran source is ',
     &        'in file "',A,'".')
40    FORMAT (1X,'You may answer: [ Any file name, - to skip this ',
     &        'question ] (Default=',A,')')
50    FORMAT (1X,'Please wait while the installer processes file "',
     &        A,'"...')
60    FORMAT (1X,'What is the name of your ',A,' distribution file ?')
70    FORMAT (1X,'Name a file where the full ',A,' source will be ',
     &        'disposed:')
90    FORMAT (1X,'Processing of the ',A,' distribution file has been ',
     &        'skipped.')
      END
C  ---------------------------------------------------------------------
      SUBROUTINE QLCR ( LINE, L, NEW, IS, IE, NIT, IERR )
C  ---------------------------------------------------------------------
C
C  Description:
C    Given a string of characters (LINE), this subroutine will 
C    separate ("crack") them into a number of items. An item is
C    a sequence of non-blank non-tab characters. For example the
C    following line:
C      I love Merlin.
C    contains the 3 items: I
C                          love
C                          Merlin.
C    Blanks and/or tabs can be embedded in an item using single quotes.
C    The following line:
C      An 'extra fast' routine.
C    contains the 3 items: An
C                          extra fast
C                          routine.
C    A single quote can be entered using the escape sequence \'
C    (even within a pair of quotes). For example the line:
C      A single quote \' 
C    contains the 4 items: A
C                        single
C                        quote
C                        '
C    The characters of all items are concatenated and returned in the
C    output string NEW. In order to separate one item from another
C    two arrays of pointers (IS, IE) are returned as well.
C    IS(I) and IE(I) contain the starting and ending positions of
C    item I, correspondingly.
C    For example the input line:
C      Hello it\'s me again.
C    contains 4 items and sets NEW to:
C      Helloit'smeagain.
C    IS(I), IE(I) are:  I    IS(I)    IE(I)    Item
C                       -----------------------------
C                       1      1        5      Hello
C                       2      6        9      it's
C                       3     10       11      me
C                       4     12       17      again.
C
C  Input arguments:
C    LINE       The line to be cracked.
C    L          Effective length of LINE.
C
C  Output arguments:
C    NEW        All items concatenated.
C    IS         IS(I) is the starting character position of item I in
C               the output character NEW.
C    IE         IE(I) is the ending character position of item I in the
C               output character NEW.
C    NIT        Number of items.
C    IERR       Error indicator.
C               IERR =  0 -> Everything ok.
C               IERR = -2 -> A closing quote is missing.
C
C  ---------------------------------------------------------------------
C  Arguments:
      CHARACTER*(*) LINE, NEW
      INTEGER IS(*), IE(*)
C  ---------------------------------------------------------------------
C  Local variables:
      CHARACTER QUOTE, SPACE
      PARAMETER ( QUOTE = '''', SPACE = ' ' )
      LOGICAL INWORD, INSTR
      CHARACTER C, TAB, ESC
      LOGICAL WHITE
      WHITE(C) = C.EQ.SPACE .OR. C.EQ.TAB
C  ---------------------------------------------------------------------
C
      TAB = CHAR(9)
      ESC = CHAR(92)
      NIT = 0
      IERR = 0
      IF (L.EQ.0) RETURN
C
      NN = 0
C
C  INWORD is set to .TRUE. as long as the character under examination
C  belongs to an item. When examining item separators (blanks/tabs),
C  INWORD is set to .FALSE.
      INWORD = .FALSE.
C
C  INSTR is set to .TRUE. while examining characters after a quote.
C  (not an escaped quote.) 
      INSTR = .FALSE.
C
C  The following loop examines all characters in LINE, one by one.
      I = 1
10    CONTINUE
      C = LINE(I:I)
      IF (C.EQ.QUOTE) THEN
         IF (INSTR) THEN
C  Closing quote.
            INSTR = .FALSE.
         ELSE
C  Opening quote.
            INSTR = .TRUE.
            IF (.NOT.INWORD) THEN
               INWORD = .TRUE.
               IF (I.EQ.L) THEN
                  GOTO 20
               ELSE
                  NIT = NIT+1
                  IS(NIT) = NN+1
               END IF
            END IF
         END IF
      ELSE IF (WHITE(C)) THEN
C  Space or tab.
         IF (INWORD) THEN
            IF (INSTR) THEN
C  A new item starts.
               NN = NN+1
               NEW(NN:NN) = C
            ELSE
               INWORD = .FALSE.
               IF (IS(NIT).GT.NN) THEN
                  NIT = NIT-1
               ELSE
                  IE(NIT) = NN
               END IF
            END IF
         END IF
      ELSE IF (C.EQ.ESC) THEN
C  The escape character (backslash).
         IF (I.EQ.L) THEN
C  The escape character is the last one in LINE.
            NN = NN+1
            NEW(NN:NN) = C
            IF (.NOT.INWORD) THEN
               NIT = NIT+1
               IS(NIT) = NN
               INWORD = .TRUE.
            END IF
            GOTO 20
         ELSE
C  Something follows the escape character.
            I = I+1
            C = LINE(I:I)
            IF (.NOT.INWORD) THEN
               NIT = NIT+1
               IS(NIT) = NN+1
               INWORD = .TRUE.
            END IF
            IF (C.EQ.QUOTE) THEN
C  A quote follows the escape character. Add it to the current item.
               NN = NN+1
               NEW(NN:NN) = QUOTE
            ELSE
C  A character other than a quote follows the escape character.
               NN = NN+1
               NEW(NN:NN) = ESC
               GOTO 10
            END IF
         END IF
      ELSE
C  Any other character.
         IF (INWORD) THEN
C  Add the character to the current item.
            NN = NN+1
            NEW(NN:NN) = C
         ELSE
C  Start a new item.
            INWORD = .TRUE.
            NN = NN+1
            NEW(NN:NN) = C
            NIT = NIT+1
            IS(NIT) = NN
         END IF
      END IF
      I = I+1
      IF (I.LE.L) GOTO 10
C
C  All characters in LINE have been processed. Set the ending pointer
C  for the last item. Also check whether a closing quote is missing.
20    CONTINUE
      IF (INWORD) THEN
         IF (IS(NIT).GT.NN) THEN
            NIT = NIT-1
         ELSE
            IE(NIT) = NN
         END IF
         IF (INSTR) IERR = -2
      END IF
C
      END
C  ---------------------------------------------------------------------
      SUBROUTINE SMACAC ( COMACC )
C  ---------------------------------------------------------------------
C
C  Description:
C    This routine determines the relative machine accuracy (COMACC)
C    in single precision.
C
C  Output arguments:
C    COMACC     Relative machine accuracy in single precision.
C
C  ---------------------------------------------------------------------
      TEN = 10.
      ONE = 1.
      DO 10,I=1,1000
         COMACC = TEN**(-I)
         X1 = ONE+COMACC
         X2 = ONE-COMACC
         IF (X1.EQ.ONE .OR. X2.EQ.ONE) THEN
            COMACC = TEN**(-I+1)
            RETURN
         END IF
10    CONTINUE
C
      END
C  ---------------------------------------------------------------------
      SUBROUTINE TOINT ( STR, LE, N, IERR )
C  ---------------------------------------------------------------------
C
C  Description:
C    Converts an integer stored in a string (STR) to its numeric
C    representation. Leading/trailing blanks/tabs in STR are ignored.
C
C  Input arguments:
C    STR        The string to convert.
C    LE         Effective length of STR.
C
C  Output arguments:
C    N          Integer representation of STR.
C    IERR       Error indicator.
C               IERR =  0 -> Conversion succeeded.
C               IERR = -2 -> Conversion failed. STR does not contain
C                            a proper integer.
C
C  ---------------------------------------------------------------------
C  Arguments:
      CHARACTER*(*) STR
C  ---------------------------------------------------------------------
C  Local variables:
      CHARACTER C, TAB
      LOGICAL NUMBER
      NUMBER(C) = C.GE.'0' .AND. C.LE.'9'
C  ---------------------------------------------------------------------
C
      TAB = CHAR(9)
C
C  Skip leading blanks.
      DO 60,I=1,LE
         C = STR(I:I)
         IF (C.NE.' ' .AND. C.NE.TAB) THEN
            NC = I
            GOTO 70
         END IF
60    CONTINUE
C
C  The string is full of blanks/tabs.
      IERR = -2
      RETURN
C
70    CONTINUE
C
C  Remove trailing blanks/tabs.
C  At least one non-white space character is present.
      DO 80,I=LE,NC,-1
         C = STR(I:I)
         IF (C.NE.' ' .AND. C.NE.TAB) THEN
            IEND = I
            GOTO 90
         END IF
80    CONTINUE
      WRITE (*,*) 'TOINT: String full of blanks.'
      STOP
C
90    CONTINUE
      N = 0
      IOFF = ICHAR('0')
C
C  Check for a sign.
      C = STR(1:1)
      IF (C.EQ.'+') THEN
         ISI = 1
         IPOS = NC+1
      ELSE IF (C.EQ.'-') THEN
         ISI = -1
         IPOS = NC+1
      ELSE
         ISI = 1
         IPOS = NC
      END IF
C
C  Convert the number.
      IF (IPOS.GT.IEND) THEN
         IERR = -2
         RETURN
      END IF
      DO 10,I=IPOS,IEND
         C = STR(I:I)
         IF (NUMBER(C)) THEN
            N = 10*N+ICHAR(C)-IOFF
         ELSE
            IERR = -2
            RETURN
         END IF
10    CONTINUE
C
      N = ISI*N
      IERR = 0
C
      END
C  ---------------------------------------------------------------------
      SUBROUTINE UPPER ( CHA, LL )
C  ---------------------------------------------------------------------
C
C  Description:
C    Converts to upper case a string of characters. Assumes the ASCII
C    character set.
C
C  Input arguments:
C    LL         Effective length of CHA.
C
C  Input / Output arguments:
C    CHA        On input the character to be converted.
C               On output lower case characters are converted to their 
C               upper case equivalents.
C
C  ---------------------------------------------------------------------
C  Arguments:
      CHARACTER*(*) CHA
C  ---------------------------------------------------------------------
C  Local variables:
      CHARACTER C
      LOGICAL ISCAP
C  ---------------------------------------------------------------------
C
      DO 10,I=1,LL
         C = CHA(I:I)
         IF (.NOT.ISCAP(C)) THEN
            IC = ICHAR(C)
            IF (IC.GE.97 .AND. IC.LE.122) CHA(I:I) = CHAR(IC-32)
         END IF
10    CONTINUE
C
      END
